SystemOrganization addCategory: #'GT-Playground'!

GLMCompositePresentation subclass: #GTPlayground
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

GTPlayground class
	instanceVariableNames: 'repository'!

!GTPlayground commentStamp: 'TudorGirba 2/10/2014 11:31' prior: 0!
self open.
self reset.

Playground is the correspondent of a classic Smalltalk Workspace. The problem with the name Workspace is that it implies that work should be carried out in this space, while this is not a best practice. Playground describes better the intention of providing a place in which we can quickly play with some code.

self registerToolsOn: Smalltalk tools
!

GTPlayground class
	instanceVariableNames: 'repository'!

!GTPlayground class methodsFor: 'instance creation' stamp: 'TudorGirba 2/9/2014 00:36'!
open
	"self open"
	| page |
	page := GTPlaygroundPage new.
	^ self new openOn: page! !

!GTPlayground class methodsFor: 'tools registry' stamp: 'TudorGirba 2/9/2014 01:10'!
registerToolsOn: registry
	"Add ourselves to registry. See [Smalltalk tools]"
	"self registerToolsOn: Smalltalk tools" 
	registry register: self as: #workspace
! !

!GTPlayground class methodsFor: 'accessing' stamp: 'TudorGirba 2/8/2014 22:54'!
repository
	^ repository ifNil: [ repository := OrderedCollection new ]! !

!GTPlayground class methodsFor: 'accessing' stamp: 'TudorGirba 2/9/2014 00:37'!
reset
	repository := nil! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/10/2014 06:38'!
actionsForPreviousContents
	^ self class repository reverse
		collect: [ :each | 
			GLMGenericAction new
				title: (each content asString contractTo: 50);
				action: [ :text | 
					self pushToRepositoryFrom: text.
					text entity: each.
					self class repository remove: each.
					text update ];
				yourself ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/10/2014 06:35'!
codeIn: a
	^ a smalltalkCode
		title: [ :page | page title ];
		format: [ :page | page content ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Open'
			with: [ :text :page | 
				page content: text text.
				Compiler evaluate: text selectedText for: nil logged: false ];
		dynamicActions: [ self actionsForPreviousContents ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/9/2014 01:12'!
compose
	self
		title: 'Playground';
		custom:
			(GTInspector new first
				noActions;
				showFirst: [ :a | self codeIn: a ];
				yourself);
		on: GLMBrowserClosing do: [ 
			"This is a hack for the moment.
			We need a better mechanism from Glamour to help 
			us keep the model in sync"
			self entity
					content: self first panes first presentations first text.
			self entity content asString trimBoth isEmpty
				ifFalse: [ self class repository add: self entity ] ]! !

!GTPlayground methodsFor: 'building' stamp: 'TudorGirba 2/9/2014 11:42'!
pushToRepositoryFrom: aTextPresentation
	| page |
	page := GTPlaygroundPage new.
	page content: aTextPresentation text.
	page content asString trimBoth isEmpty
		ifFalse: [ self class repository add: page ] ! !

Object subclass: #GTPlaygroundPage
	instanceVariableNames: 'title content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Playground'!

!GTPlaygroundPage commentStamp: 'TudorGirba 2/8/2014 22:59' prior: 0!
GTPlayground open!

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content
	^ content! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
content: anObject
	content := anObject! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/8/2014 22:59'!
initialize
	content := ''.
	title := 'Playground'! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title
	^ title! !

!GTPlaygroundPage methodsFor: 'accessing' stamp: 'TudorGirba 2/3/2011 15:41'!
title: anObject
	title := anObject! !
